-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Scheduler - Individual Views Customization
To customize a view, configure its settings in an object inside the views[] array. You should specify the view's type and other properties to override global view settings.
This demo customizes two views - Week and Work Week - in the following manner:
- Both views group appointments by resources.
- Both views use the dateCellTemplate to change the appearance of date cells.
- The Work Week view uses the startDayHour and endDayHour properties to set custom first and last hours on the time scale.
Day and Month views use default settings.
Backend API
$(() => {
const dayOfWeekNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
const dateCellTemplate = function (cellData, index, container) {
container.append(
$('<div />')
.addClass('name')
.text(dayOfWeekNames[cellData.date.getDay()]),
$('<div />')
.addClass('number')
.text(cellData.date.getDate()),
);
};
$('#scheduler').dxScheduler({
timeZone: 'America/Los_Angeles',
height: 730,
dataSource: data,
showAllDayPanel: false,
views: ['day',
{
type: 'week',
groups: ['typeId'],
dateCellTemplate,
}, {
type: 'workWeek',
startDayHour: 9,
endDayHour: 18,
groups: ['priorityId'],
dateCellTemplate,
},
'month'],
currentView: 'workWeek',
currentDate: new Date(2021, 3, 27),
startDayHour: 7,
endDayHour: 23,
resources: [{
fieldExpr: 'priorityId',
allowMultiple: false,
dataSource: priorityData,
label: 'Priority',
icon: 'tags',
}, {
fieldExpr: 'typeId',
allowMultiple: false,
dataSource: typeData,
label: 'Type',
}],
editing: {
form: {
items: [
{
name: 'mainGroup',
items: [
'subjectGroup',
'dateGroup',
'repeatGroup',
{
name: 'resourcesGroup',
items: [
{
name: 'priorityIdGroup',
colCount: 3,
colCountByScreen: {
xs: 3,
},
items: ['priorityIdIcon', 'priorityIdEditor', 'typeIdEditor'],
},
],
},
'descriptionGroup',
],
},
'recurrenceGroup',
],
},
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
</div>
</body>
</html>
.dx-scheduler-work-space-week .dx-scheduler-header-panel-cell,
.dx-scheduler-work-space-work-week .dx-scheduler-header-panel-cell {
text-align: center;
vertical-align: middle;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .name {
font-size: 13px;
line-height: 15px;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .number {
font-size: 15px;
line-height: 15px;
}
const data = [{
text: 'Walking a dog',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-26T15:00:00.000Z'),
endDate: new Date('2021-04-26T15:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,TU,WE,TH,FR;UNTIL=20210502',
},
{
text: 'Website Re-Design Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Go Grocery Shopping',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-27T01:30:00.000Z'),
endDate: new Date('2021-04-27T02:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,WE,FR;UNTIL=20210502',
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
}, {
text: 'Visiting a Doctor',
priorityId: 2,
typeId: 1,
startDate: new Date('2021-05-01T17:00:00.000Z'),
endDate: new Date('2021-05-01T20:30:00.000Z'),
},
];
const priorityData = [{
text: 'Low Priority',
id: 1,
color: '#fcb65e',
}, {
text: 'High Priority',
id: 2,
color: '#e18e92',
},
];
const typeData = [{
text: 'Home',
id: 1,
color: '#b6d623',
}, {
text: 'Work',
id: 2,
color: '#679ec5',
},
];

Backend API
import React from 'react';
import Scheduler, {
Resource,
View,
Editing,
Form as SchedulerForm,
Item,
} from 'devextreme-react/scheduler';
import { data, priorityData, typeData } from './data.ts';
const currentDate = new Date(2021, 3, 27);
const dayOfWeekNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
const typeGroups = ['typeId'];
const priorityGroups = ['priorityId'];
type DateCellProps = {
data: any;
};
const DateCell = ({ data: cellData }: DateCellProps) => (
<>
<div className="name">{dayOfWeekNames[cellData.date.getDay()]}</div>
<div className="number">{cellData.date.getDate()}</div>
</>
);
const App = () => (
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
defaultCurrentView="workWeek"
showAllDayPanel={false}
defaultCurrentDate={currentDate}
height={730}
startDayHour={7}
endDayHour={23}
>
<View type="day" />
<View type="week" groups={typeGroups} dateCellComponent={DateCell} />
<View
type="workWeek"
groups={priorityGroups}
startDayHour={9}
endDayHour={18}
dateCellComponent={DateCell}
/>
<View type="month" />
<Resource
dataSource={priorityData}
fieldExpr="priorityId"
label="Priority"
allowMultiple={false}
icon="tags"
/>
<Resource
dataSource={typeData}
fieldExpr="typeId"
label="Type"
allowMultiple={false}
/>
<Editing>
<SchedulerForm>
<Item name="mainGroup">
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="resourcesGroup">
<Item name="priorityIdGroup" colCount={3} colCountByScreen={{ xs: 3 }}>
<Item name="priorityIdIcon" />
<Item name="priorityIdEditor" />
<Item name="typeIdEditor" />
</Item>
</Item>
<Item name="descriptionGroup" />
</Item>
<Item name="recurrenceGroup" />
</SchedulerForm>
</Editing>
</Scheduler>
);
export default App;
import React from 'react';
import Scheduler, {
Resource,
View,
Editing,
Form as SchedulerForm,
Item,
} from 'devextreme-react/scheduler';
import { data, priorityData, typeData } from './data.js';
const currentDate = new Date(2021, 3, 27);
const dayOfWeekNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
const typeGroups = ['typeId'];
const priorityGroups = ['priorityId'];
const DateCell = ({ data: cellData }) => (
<>
<div className="name">{dayOfWeekNames[cellData.date.getDay()]}</div>
<div className="number">{cellData.date.getDate()}</div>
</>
);
const App = () => (
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
defaultCurrentView="workWeek"
showAllDayPanel={false}
defaultCurrentDate={currentDate}
height={730}
startDayHour={7}
endDayHour={23}
>
<View type="day" />
<View
type="week"
groups={typeGroups}
dateCellComponent={DateCell}
/>
<View
type="workWeek"
groups={priorityGroups}
startDayHour={9}
endDayHour={18}
dateCellComponent={DateCell}
/>
<View type="month" />
<Resource
dataSource={priorityData}
fieldExpr="priorityId"
label="Priority"
allowMultiple={false}
icon="tags"
/>
<Resource
dataSource={typeData}
fieldExpr="typeId"
label="Type"
allowMultiple={false}
/>
<Editing>
<SchedulerForm>
<Item name="mainGroup">
<Item name="subjectGroup" />
<Item name="dateGroup" />
<Item name="repeatGroup" />
<Item name="resourcesGroup">
<Item
name="priorityIdGroup"
colCount={3}
colCountByScreen={{ xs: 3 }}
>
<Item name="priorityIdIcon" />
<Item name="priorityIdEditor" />
<Item name="typeIdEditor" />
</Item>
</Item>
<Item name="descriptionGroup" />
</Item>
<Item name="recurrenceGroup" />
</SchedulerForm>
</Editing>
</Scheduler>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Appointment = SchedulerTypes.Appointment & { priorityId: number; typeId: number; };
type Resource = {
text: string;
id: number;
color: string;
};
export const data: Appointment[] = [{
text: 'Walking a dog',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-26T15:00:00.000Z'),
endDate: new Date('2021-04-26T15:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,TU,WE,TH,FR;UNTIL=20210502',
},
{
text: 'Website Re-Design Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Go Grocery Shopping',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-27T01:30:00.000Z'),
endDate: new Date('2021-04-27T02:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,WE,FR;UNTIL=20210502',
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
}, {
text: 'Visiting a Doctor',
priorityId: 2,
typeId: 1,
startDate: new Date('2021-05-01T17:00:00.000Z'),
endDate: new Date('2021-05-01T20:30:00.000Z'),
}];
export const priorityData: Resource[] = [{
text: 'Low Priority',
id: 1,
color: '#fcb65e',
}, {
text: 'High Priority',
id: 2,
color: '#e18e92',
}];
export const typeData: Resource[] = [{
text: 'Home',
id: 1,
color: '#b6d623',
}, {
text: 'Work',
id: 2,
color: '#679ec5',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const data = [
{
text: 'Walking a dog',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-26T15:00:00.000Z'),
endDate: new Date('2021-04-26T15:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,TU,WE,TH,FR;UNTIL=20210502',
},
{
text: 'Website Re-Design Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
},
{
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
},
{
text: 'Install New Router in Dev Room',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
},
{
text: 'Go Grocery Shopping',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-27T01:30:00.000Z'),
endDate: new Date('2021-04-27T02:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,WE,FR;UNTIL=20210502',
},
{
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
},
{
text: 'Final Budget Review',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
},
{
text: 'New Brochures',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
},
{
text: 'Install New Database',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
},
{
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
},
{
text: 'Upgrade Personal Computers',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
},
{
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
},
{
text: 'Brochure Design Review',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
},
{
text: 'Create Icons for Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
},
{
text: 'Upgrade Server Hardware',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
},
{
text: 'Submit New Website Design',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
},
{
text: 'Launch New Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
},
{
text: 'Visiting a Doctor',
priorityId: 2,
typeId: 1,
startDate: new Date('2021-05-01T17:00:00.000Z'),
endDate: new Date('2021-05-01T20:30:00.000Z'),
},
];
export const priorityData = [
{
text: 'Low Priority',
id: 1,
color: '#fcb65e',
},
{
text: 'High Priority',
id: 2,
color: '#e18e92',
},
];
export const typeData = [
{
text: 'Home',
id: 1,
color: '#b6d623',
},
{
text: 'Work',
id: 2,
color: '#679ec5',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-scheduler-work-space-week .dx-scheduler-header-panel-cell,
.dx-scheduler-work-space-work-week .dx-scheduler-header-panel-cell {
text-align: center;
vertical-align: middle;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .name {
font-size: 13px;
line-height: 15px;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .number {
font-size: 15px;
line-height: 15px;
}

Backend API
<template>
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="dataSource"
:current-date="currentDate"
:start-day-hour="7"
:end-day-hour="23"
:show-all-day-panel="false"
height="730"
current-view="workWeek"
>
<DxView
type="day"
/>
<DxView
:groups="typeGroups"
type="week"
date-cell-template="dateCellSlot"
/>
<DxView
:groups="priorityGroups"
:start-day-hour="9"
:end-day-hour="18"
type="workWeek"
date-cell-template="dateCellSlot"
/>
<DxView
type="month"
/>
<DxResource
:data-source="priorityData"
:allow-multiple="false"
field-expr="priorityId"
label="Priority"
icon="tags"
/>
<DxResource
:data-source="typeData"
:allow-multiple="false"
field-expr="typeId"
label="Type"
/>
<DxEditing>
<DxSchedulerForm>
<DxItem name="mainGroup">
<DxItem name="subjectGroup"/>
<DxItem name="dateGroup"/>
<DxItem name="repeatGroup"/>
<DxItem name="resourcesGroup">
<DxItem
:col-count="3"
:col-count-by-screen="{ xs: 3 }"
name="priorityIdGroup"
>
<DxItem name="priorityIdIcon"/>
<DxItem name="priorityIdEditor"/>
<DxItem name="typeIdEditor"/>
</DxItem>
</DxItem>
<DxItem name="descriptionGroup"/>
</DxItem>
<DxItem name="recurrenceGroup"/>
</DxSchedulerForm>
</DxEditing>
<template #dateCellSlot="{ data: dateCell }">
<DateCell :cell-data="dateCell"/>
</template>
</DxScheduler>
</template>
<script setup lang="ts">
import DxScheduler, {
DxResource,
DxView,
DxEditing,
DxForm as DxSchedulerForm,
} from 'devextreme-vue/scheduler';
import { DxItem } from 'devextreme-vue/form';
import DateCell from './DateCell.vue';
import { data, priorityData, typeData } from './data.ts';
const dataSource = data;
const typeGroups = ['typeId'];
const priorityGroups = ['priorityId'];
const currentDate = new Date(2021, 3, 27);
</script>
<style scoped>
.dx-scheduler-work-space-week .dx-scheduler-header-panel-cell,
.dx-scheduler-work-space-work-week .dx-scheduler-header-panel-cell {
text-align: center;
vertical-align: middle;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .name {
font-size: 13px;
line-height: 15px;
}
.dx-scheduler-work-space .dx-scheduler-header-panel-cell .number {
font-size: 15px;
line-height: 15px;
}
</style>
<template>
<div>
<div class="name">{{ dayOfWeekNames[cellData.date.getDay()] }}</div>
<div class="number"> {{ cellData.date.getDate() }}</div>
</div>
</template>
<script setup lang="ts">
withDefaults(defineProps<{
cellData?: any,
}>(), {
cellData: () => {},
});
const dayOfWeekNames = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const data = [{
text: 'Walking a dog',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-26T15:00:00.000Z'),
endDate: new Date('2021-04-26T15:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,TU,WE,TH,FR;UNTIL=20210502',
},
{
text: 'Website Re-Design Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Go Grocery Shopping',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-27T01:30:00.000Z'),
endDate: new Date('2021-04-27T02:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,WE,FR;UNTIL=20210502',
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
}, {
text: 'Visiting a Doctor',
priorityId: 2,
typeId: 1,
startDate: new Date('2021-05-01T17:00:00.000Z'),
endDate: new Date('2021-05-01T20:30:00.000Z'),
},
];
export const priorityData = [{
text: 'Low Priority',
id: 1,
color: '#fcb65e',
}, {
text: 'High Priority',
id: 2,
color: '#e18e92',
},
];
export const typeData = [{
text: 'Home',
id: 1,
color: '#b6d623',
}, {
text: 'Work',
id: 2,
color: '#679ec5',
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-scheduler
timeZone="America/Los_Angeles"
[height]="730"
[dataSource]="dataSource"
dateCellTemplate="dateCellTemplate"
[showAllDayPanel]="false"
currentView="workWeek"
[currentDate]="currentDate"
[startDayHour]="7"
[endDayHour]="23"
>
<dxi-scheduler-view type="day"></dxi-scheduler-view>
<dxi-scheduler-view
type="week"
[groups]="['typeId']"
dateCellTemplate="dateCellTemplate"
></dxi-scheduler-view>
<dxi-scheduler-view
type="workWeek"
[startDayHour]="9"
[endDayHour]="18"
[groups]="['priorityId']"
dateCellTemplate="dateCellTemplate"
></dxi-scheduler-view>
<dxi-scheduler-view type="month"></dxi-scheduler-view>
<dxi-scheduler-resource
fieldExpr="priorityId"
[allowMultiple]="false"
[dataSource]="priorityData"
label="Priority"
icon="tags"
>
</dxi-scheduler-resource>
<dxi-scheduler-resource
fieldExpr="typeId"
[allowMultiple]="false"
[dataSource]="typeData"
label="Type"
>
</dxi-scheduler-resource>
<dxo-scheduler-editing>
<dxo-scheduler-form>
<dxi-scheduler-item name="mainGroup">
<dxi-scheduler-item name="subjectGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="dateGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="repeatGroup"></dxi-scheduler-item>
<dxi-scheduler-item name="resourcesGroup">
<dxi-scheduler-item
name="priorityIdGroup"
[colCount]="3"
[colCountByScreen]="{ xs: 3 }"
>
<dxi-scheduler-item name="priorityIdIcon"></dxi-scheduler-item>
<dxi-scheduler-item name="priorityIdEditor"></dxi-scheduler-item>
<dxi-scheduler-item name="typeIdEditor"></dxi-scheduler-item>
</dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item name="descriptionGroup"></dxi-scheduler-item>
</dxi-scheduler-item>
<dxi-scheduler-item name="recurrenceGroup"></dxi-scheduler-item>
</dxo-scheduler-form>
</dxo-scheduler-editing>
<div *dxTemplate="let data of 'dateCellTemplate'">
<div class="name">{{
["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"][data.date.getDay()]
}}</div>
<div class="number">{{ data.date.getDate() }}</div>
</div>
</dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule } from 'devextreme-angular';
import { DataSource } from 'devextreme-angular/common/data';
import { Service, PriorityData, TypeData } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
],
})
export class AppComponent {
dataSource: DataSource;
currentDate: Date = new Date(2021, 3, 27);
priorityData: PriorityData[];
typeData: TypeData[];
constructor(service: Service) {
this.dataSource = new DataSource({
store: service.getData(),
});
this.priorityData = service.getPriorityData();
this.typeData = service.getTypeData();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-scheduler-work-space-week .dx-scheduler-header-panel-cell,
::ng-deep .dx-scheduler-work-space-work-week .dx-scheduler-header-panel-cell {
text-align: center;
vertical-align: middle;
}
::ng-deep .dx-scheduler-work-space .dx-scheduler-header-panel-cell .name {
font-size: 13px;
line-height: 15px;
}
::ng-deep .dx-scheduler-work-space .dx-scheduler-header-panel-cell .number {
font-size: 15px;
line-height: 15px;
}
import { Injectable } from '@angular/core';
export class Data {
text: string;
priorityId: number;
typeId: number;
startDate: Date;
endDate: Date;
recurrenceRule?: string;
}
export class PriorityData {
text: string;
id: number;
color: string;
}
export class TypeData {
text: string;
id: number;
color: string;
}
const data: Data[] = [{
text: 'Walking a dog',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-26T15:00:00.000Z'),
endDate: new Date('2021-04-26T15:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,TU,WE,TH,FR;UNTIL=20210502',
}, {
text: 'Website Re-Design Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T16:00:00.000Z'),
endDate: new Date('2021-04-26T18:30:00.000Z'),
}, {
text: 'Book Flights to San Fran for Sales Trip',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-26T19:00:00.000Z'),
endDate: new Date('2021-04-26T20:00:00.000Z'),
}, {
text: 'Install New Router in Dev Room',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-26T21:30:00.000Z'),
endDate: new Date('2021-04-26T22:30:00.000Z'),
}, {
text: 'Go Grocery Shopping',
priorityId: 1,
typeId: 1,
startDate: new Date('2021-04-27T01:30:00.000Z'),
endDate: new Date('2021-04-27T02:30:00.000Z'),
recurrenceRule: 'FREQ=DAILY;BYDAY=MO,WE,FR;UNTIL=20210502',
}, {
text: 'Approve Personal Computer Upgrade Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T17:00:00.000Z'),
endDate: new Date('2021-04-27T18:00:00.000Z'),
}, {
text: 'Final Budget Review',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T19:00:00.000Z'),
endDate: new Date('2021-04-27T20:35:00.000Z'),
}, {
text: 'New Brochures',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-27T21:30:00.000Z'),
endDate: new Date('2021-04-27T22:45:00.000Z'),
}, {
text: 'Install New Database',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T16:45:00.000Z'),
endDate: new Date('2021-04-28T18:15:00.000Z'),
}, {
text: 'Approve New Online Marketing Strategy',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-28T19:00:00.000Z'),
endDate: new Date('2021-04-28T21:00:00.000Z'),
}, {
text: 'Upgrade Personal Computers',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-28T22:15:00.000Z'),
endDate: new Date('2021-04-28T23:30:00.000Z'),
}, {
text: 'Prepare 2021 Marketing Plan',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-29T18:00:00.000Z'),
endDate: new Date('2021-04-29T20:30:00.000Z'),
}, {
text: 'Brochure Design Review',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-29T21:00:00.000Z'),
endDate: new Date('2021-04-29T22:30:00.000Z'),
}, {
text: 'Create Icons for Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T17:00:00.000Z'),
endDate: new Date('2021-04-30T18:30:00.000Z'),
}, {
text: 'Upgrade Server Hardware',
priorityId: 1,
typeId: 2,
startDate: new Date('2021-04-30T21:30:00.000Z'),
endDate: new Date('2021-04-30T23:00:00.000Z'),
}, {
text: 'Submit New Website Design',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T23:30:00.000Z'),
endDate: new Date('2021-05-01T01:00:00.000Z'),
}, {
text: 'Launch New Website',
priorityId: 2,
typeId: 2,
startDate: new Date('2021-04-30T19:20:00.000Z'),
endDate: new Date('2021-04-30T21:00:00.000Z'),
}, {
text: 'Visiting a Doctor',
priorityId: 2,
typeId: 1,
startDate: new Date('2021-05-01T17:00:00.000Z'),
endDate: new Date('2021-05-01T20:30:00.000Z'),
},
];
const priorityData: PriorityData[] = [{
text: 'Low Priority',
id: 1,
color: '#fcb65e',
}, {
text: 'High Priority',
id: 2,
color: '#e18e92',
},
];
const typeData: TypeData[] = [{
text: 'Home',
id: 1,
color: '#b6d623',
}, {
text: 'Work',
id: 2,
color: '#679ec5',
},
];
@Injectable()
export class Service {
getPriorityData() {
return priorityData;
}
getTypeData() {
return typeData;
}
getData() {
return data;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>